<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Bank App</title>
</head>

<body>
    <script src="assets_accounts.js"></script>
    <script>

        // Ex 2 
        // EE154770478
        // const ex1Customer = accounts.find(
        //     function(customer) {
        //         return customer.number === 'EE154770478';
        //     }
        // );
        const ex1Customer = accounts.find(a => a.number === 'EE154770478');
        console.log('Ex 2', ex1Customer);

        // Ex 3
        const ex2Customer = accounts.find(a => a.number === 'LT937416401');
        console.log('Ex 3', ex2Customer);

        // Ex 4
        console.log('Ex 4', accounts.find(a => a.number === 'LV587816561') != null);
        console.log('Ex 4', accounts.some(a => a.number === 'LV587816561'));

        // Ex 5
        console.log('Ex 5', accounts.some(account => account.number === 'EE251446912'));

        // Ex 6
        const richCustomers = accounts.filter(acc => acc.balance > 500);
        console.log('Ex 6', richCustomers);

        // Ex 7 (reduce())
        console.log('Ex 7',
            accounts
                .filter(a => a.balance > 1000)
                .reduce((currentTotal, acc) => currentTotal + acc.balance, 0)
        );

        // Ex 8
        console.log('Ex 8',
            accounts
                .reduce((currentTotal, acc) => currentTotal + acc.balance, 0)
        );

        // Ex 9
        console.log('Ex 9',
            accounts
                .filter(x => x.number.startsWith('EE'))
                .reduce((currentTotal, currentAccount) => { return currentTotal + currentAccount.balance }, 0)
        );

        // Ex 12
        // accounts
        //     .filter(a => a.number.startsWith('LT'))
        //     .forEach(a => console.log(`${a.firstName} ${a.lastName}`));

        console.log(
            'Ex 12',
            accounts
                .filter(a => a.number.startsWith('LT'))
                .map(a => `${a.firstName} ${a.lastName}`)
                .join(', ')
        );

        // Ex 14
        console.log('Ex 14', accounts.every(a => a.balance >= 1));


        // Array.prototype.myOwnFun = () => console.log('Llalalalalal');
        // let arr = [1, 2, 3];
        // arr.myOwnFun();

    </script>
</body>

</html>